Magellan Linux

Diff of /branches/mage-next/src/smage2.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 85 by niro, Wed Jun 1 16:10:19 2005 UTC revision 1659 by niro, Sat Jan 14 00:01:52 2012 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3    
4  # compiles/installs .smage2 source install scripts  # compiles/installs .smage2 source install scripts
5  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
6    
7  # SMAGE2  # TODO: record dynlib, gz | xz database
 # $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.11 2005-06-01 16:10:19 niro Exp $  
8    
 #01.10.2004  
 # added ccache support  
 # added distcc support  
9    
10  ## setup ##  # set default user mage.rc
11  SMAGEVERSION=0.3.6-r16  : ${MAGERC="/etc/mage.rc"}
 PKGSUFFIX="mpk"  
 SMAGENAME="$1"  
 SMAGESUFFIX="smage2"  
 #SOURCEDIR="/bootstrap/sources"  
 #SMAGESCRIPTSDIR="/bootstrap/smage2-install-scripts"  
 #SMAGE2RSYNC="rsync://192.168.0.2/smage2-scripts"  
 MLIBDIR=/usr/lib/mage  
   
 source /etc/mage.rc  
   
 showversion() {  
  echo -en "Magellan Source Install v${SMAGEVERSION} "  
  echo -e  "-- Niels Rogalla (niro@magellan-linux.de)"  
 }  
   
 die() {  
  xtitleclean  
  echo "SMAGE failed: $@"  
  exit 1  
 }  
   
 xtitle() {  
  if [ ${TERM} == "xterm" ]  
  then  
  echo -ne "\033]0;[sMage: $@]\007"  
  fi  
  return 0  
 }  
   
 xtitleclean() {  
  if [ ${TERM} == "xterm" ]  
  then  
  echo -ne "\033]0;\007"  
  fi  
  return 0  
 }  
   
 syncsmage2() {  
  xtitle "Updating smage2-script tree ..."  
  local i  
  for i in ${SMAGE2RSYNC}  
  do  
  rsync \  
  --recursive \  
  --links \  
  --perms \  
  --times \  
  --devices \  
  --timeout=600 \  
  --verbose \  
  --compress \  
  --progress \  
  --stats \  
  --delete \  
  --delete-after \  
  ${i} ${SMAGESCRIPTSDIR}  
   
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
   
  done  
   
  #clean up backup files (foo~)  
  find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'  
   
  xtitleclean  
 }  
   
 # $1 filename  
 get_db_md5_sum() {  
  local DB_FILE  
  local MD5_FILE  
  local i  
   
  DB_ENTRY="$(basename $1)"  
  MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} ${SMAGESUFFIX})"  
   
  i="$(cat ${MD5_FILE}| grep ${DB_ENTRY} | cut -d' ' -f1)"  
   
  echo "${i}"  
 }  
   
 download_sources() {  
   
  [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0  
   
  local EOA=${#SRC_URI[*]}  
  local my_SRC_URI  
  local my_SRC_URI_DEST  
  local my_SRC_URI_MIRROR  
  local my_SOURCEDIR  
  local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"  
  local FETCHING  
  local i mirror  
   
   
  #install SRCDIR/PNAME if not exist  
  [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}  
   
  # check if FETCHING is needed  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} &> /dev/null )  
  if [[ $? == 0 ]]  
  then  
  # md5's ok, not fetching needed  
  FETCHING=false  
  else  
  FETCHING=true  
  fi  
   
  for ((i=0; i < EOA; i++))  
  do  
  # url to file  
  my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"  
   
  # subdir in sources dir; the my_SRCI_URI file goes to there  
  my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"  
   
  # if my_src_uri_dest is not equal my_src_uri; than an other dir is used  
  if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]  
  then  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}/${my_SRC_URI_DEST}"  
  else  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}"  
  fi  
   
  # if an mirrored file than replace first the mirror uri  
  if [ -n "$(echo ${my_SRC_URI} | grep 'mirror://')" ]  
  then  
  for mirror in ${MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|mirror:/|${mirror}/sources|g")"  
   
  #echo "DEBUG: ${MY_SRC_URI}"  
  if [[ ${FETCHING} == true ]]  
  then  
  echo "==> fetching ${my_SRC_URI_MIRROR}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  else  
  #echo "DEBUG: ${SRC_URI[${i}]}"  
  if [[ ${FETCHING} == true ]]  
  then  
  echo "==> fetching ${my_SRC_URI}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI}"  
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  fi  
   
  # unset them to be shure  
  unset my_SRC_URI  
  unset my_SRC_URI_DEST  
  unset my_SRC_URI_MIRROR  
  unset my_SOURCEDIR  
  done  
12    
13   # recheck md5 sums  # export default C locale
14   echo  export LC_ALL=C
  echo ">== Checking MD5 sums:"  
  ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} ) || die "md5 failed"  
  echo  
   
  # not needed anymore  
  unset SRC_URI  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_prepare() {  
  echo "no src_prepare defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_compile() {  
  echo "no src_compile defined"  
  sleep 2  
  return 0  
 }  
   
 # dummy function, used if that not exist in smage file  
 src_install() {  
  echo "no src_install defined"  
  sleep 2  
  return 0  
 }  
   
   
 build_mage_script() {  
  return 0  
 }  
   
 mconfigure() {  
  if [ -x ./configure ]  
  then  
  ./configure \  
  --prefix=/usr \  
  --host=${CHOST} \  
  --mandir=/usr/share/man \  
  --infodir=/usr/share/info \  
  --datadir=/usr/share \  
  --sysconfdir=/etc \  
  --localstatedir=/var/lib \  
  "$@" || die "mconfigure failed"  
  else  
  echo "configure is not an executable ..."  
  exit 1  
  fi  
 }  
15    
16  minstall() {  source /etc/mage.rc.global
17   if [ -f ./[mM]akefile -o -f ./GNUmakefile ] ; then  source ${MAGERC}
18   make prefix=${BINDIR}/usr \  source ${MLIBDIR}/mage4.functions.sh
19   datadir=${BINDIR}/usr/share \  source ${MLIBDIR}/smage2.functions.sh
  infodir=${BINDIR}/usr/share/info \  
  localstatedir=${BINDIR}/var/lib \  
  mandir=${BINDIR}/usr/share/man \  
  sysconfdir=${BINDIR}/etc \  
  "$@" install || die "minstall failed"  
         else  
                 die "no Makefile found"  
         fi  
 }  
   
 mmake() {  
  make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"  
 }  
   
 munpack() {  
  local SRCFILE  
  local IFTAR  
  local DEST  
   
  SRCFILE=$1  
   
  if [ -z "$2" ]  
  then  
  DEST=${BUILDDIR}  
  else  
  DEST=$2  
  fi  
   
  case "${SRCFILE##*.}" in  
  bz2)  
  IFTAR="$(basename $SRCFILE .bz2)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  gz)  
  IFTAR="$(basename $SRCFILE .gz)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
  then  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  fi  
  ;;  
  tbz2)  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  tgz)  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}  
  ;;  
  *)  
  die "munpack failed"  
  ;;  
  esac  
 }  
   
 mpatch() {  
  local PATCHOPTS  
  local PATCHFILE  
   
  PATCHOPTS=$1  
  PATCHFILE=$2  
   
  patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}  
 }  
   
   
 minstalldocs() {  
  local docfiles  
   
  docfiles="$@"  
   
  if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]  
  then  
  install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."  
  fi  
   
  for i in ${docfiles}  
  do  
  cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."  
  install -m 0644 ${SRCDIR}/${i}.gz \  
  ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."  
  done  
 }  
   
 mstriplibs() {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 mstripbins() {  
  local stripdir="$@"  
   
  [ -z "${stripdir}" ] && stripdir=${BINDIR}  
  find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null  
 }  
   
 setup_distcc_environment(){  
  if [ -x /usr/bin/distcc ]  
  then  
  echo "Using DistCC for compilation ..."  
  export PATH=/usr/lib/distcc/bin:${PATH} || die "distcc: could not export new $PATH"  
   
  #export distcc as compiler  
 # export CC="distcc"  
 # export CXX=distcc  
   
  export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"  
   
   
  #ccache + distcc together  
  if [ "${SMAGE_USE_CCACHE}" == "true" ]  
  then  
  if [ -x /usr/bin/ccache ]  
  then  
  echo "Preparing DistCC to work together with CCache ..."  
  #export CCACHE_PREFIX="distcc" || die "distcc: could not set ccach_prefix"  
 # export CC="ccache distcc"  
 # export CXX="ccache distcc"  
  fi  
  fi  
20    
21   #creating distcc tempdir  ## setup ##
22   install -o distcc -g daemon -d ${DISTCC_DIR}  SMAGENAME="$1"
23   chmod 1777 ${DISTCC_DIR}  SMAGEVERSION="$(< ${MLIBDIR}/version)"
  fi  
 }  
24    
25  setup_ccache_environment(){  # expand PKGDIR, BUILDDIR and BINDIR with MROOT
26   if [ -x /usr/bin/ccache ]  if [[ -n ${MROOT} ]]
27   then  then
28   echo "Using CCache for compilation ..."   export PKGDIR=${MROOT}/${PKGDIR}
29   export PATH=/usr/lib/ccache/bin:${PATH} || die "ccache: could not export new $PATH"   export BUILDDIR=${MROOT}/${BUILDDIR}
30   #unset CC CXX   export BINDIR=${MROOT}/${BINDIR}
31   fi  fi
 }  
32    
33  # print out our version  # print out our version
34  showversion  showversion
35  echo  echo
36    
37  if [ -z "$1" ]  if [[ -z ${SMAGENAME} ]]
38  then  then
39   echo "No .smage2 file given. Exiting."   echo "No .smage2 file given. Exiting."
40   echo   echo
41   exit 1   exit 1
42  fi  fi
43    
44  #updating smage2-scripts  # load supported mage features
45  if [ "$1" == "update" ]  load_mage_features
46    
47    # updating smage2-scripts
48    if [[ $1 = update ]]
49  then  then
50   if [ ! -d ${SOURCEDIR} ]   if [ ! -d ${SOURCEDIR} ]
51   then   then
# Line 415  then Line 55  then
55   exit 0   exit 0
56  fi  fi
57    
58  #creates md5sums for smages to given dir  # creates md5sums for smages to given dir
59  if [ "$1" == "calcmd5" ]  if [[ $1 = calcmd5 ]]
60  then  then
61   if [ $# -ge 3 ]   if [ $# -ge 2 ]
62   then   then
63   SMAGENAME="$2"   SMAGENAME="$2"
64   MD5DIR="$3"   MD5DIR="$3"
65   source ${SMAGENAME} || die "download source failed"   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
66    
67     smagesource ${SMAGENAME} || die "download source failed"
68    
69   # overridable sourcedir; must be declared after source of the smage2   # overridable sourcedir; must be declared after source of the smage2
70   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
# Line 468  then Line 110  then
110   unset my_SRC_URI_MIRROR   unset my_SRC_URI_MIRROR
111   unset my_SOURCEDIR   unset my_SOURCEDIR
112   done   done
113    
114   echo   echo
115   echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."   echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."
116   echo   echo
117   else   else
118   echo "Usage: Calculating MD5 Sums:"   echo "Usage: Calculating MD5 Sums:"
119   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME /path/to/MD5DIR"   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
120   echo   echo
121   echo   echo
122   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
123   echo   echo
124   exit 1   exit 1
125   fi   fi
126    
127   exit 0   exit 0
128  fi  fi
129    
130  #download sources  # download sources
131  if [ "$1" == "download" -a -n "$2" ]  if [ "$1" == "download" -a -n "$2" ]
132  then  then
  showversion  
133   if [ ! -d ${SMAGESCRIPTSDIR} ]   if [ ! -d ${SMAGESCRIPTSDIR} ]
134   then   then
135   install -d ${SMAGESCRIPTSDIR}   install -d ${SMAGESCRIPTSDIR}
# Line 497  then Line 138  then
138   # get smage   # get smage
139   SMAGENAME="$2"   SMAGENAME="$2"
140   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
141   source ${SMAGENAME} || die "download source failed"   smagesource ${SMAGENAME} || die "download source failed"
142    
143   download_sources   download_sources
144   exit 0   exit 0
145  fi  fi
146    
147  if [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ]  # regen-mage-tree
148    if [ "$1" == "only-regen-tree" -a -n "$2" ]
149  then  then
150   die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."   # set correct SMAGENAME
151  fi   SMAGENAME="$2"
152     MD5DIR="$(dirname ${SMAGENAME})/md5"
153     smagesource ${SMAGENAME} || die "regen: smage2 not found"
154    
155  if [ -z "`basename ${SMAGENAME}|grep .${SMAGESUFFIX}`" ]   regen_mage_tree
 then  
  die "File '`basename ${SMAGENAME}`' is not a sMage v${SMAGEVERSION} file. Aborting."  
 fi  
156    
157  if [ -z "${SOURCEDIR}" ]   # build several targets
158  then   if [[ -n ${MAGE_TARGETS} ]]
159   die "\$SOURCEDIR not found. Please setup your mage.rc correctly."   then
160  fi   for target in ${MAGE_TARGETS}
161     do
162     # build md5sum for existing packages
163     generate_package_md5sum \
164     --pcat "${PCAT}" \
165     --pname "${PNAME}" \
166     --pver "${PVER}" \
167     --pbuild "${PBUILD}" \
168     --parch "${ARCH}" \
169     --target "${target}"
170     done
171    
172  if [ -z "${SMAGESCRIPTSDIR}" ]   # build several subpackages
173  then   elif [[ -n ${SPLIT_PACKAGES} ]]
174   die "\$SMAGESCRIPTSDIR not found. Please setup your mage.rc correctly."   then
175  fi   split_save_variables
176     for subpackage in ${SPLIT_PACKAGES}
177     do
178     # get the right variables for the split
179     export PNAME="${subpackage}"
180     split_info_${subpackage}
181     # fix PCATEGORIE -> PCAT
182     if [[ ! -z ${PCATEGORIE} ]]
183     then
184     PCAT="${PCATEGORIE}"
185     unset PCATEGORIE
186     fi
187     # build md5sum for existing packages
188     generate_package_md5sum \
189     --pcat "${PCAT}" \
190     --pname "${PNAME}" \
191     --pver "${PVER}" \
192     --pbuild "${PBUILD}" \
193     --parch "${ARCH}"
194     # restore smage environment
195     split_restore_variables
196     done
197     # unset all saved smage variables
198     split_unset_variables
199    
200  if [ -z "${SMAGE2RSYNC}" ]   else
201  then   # build md5sum for existing packages
202   echo "\$SMAGE2RSYNC not found. Please setup your mage.rc correctly."   generate_package_md5sum \
203   exit 1   --pcat "${PCAT}" \
204  fi   --pname "${PNAME}" \
205     --pver "${PVER}" \
206     --pbuild "${PBUILD}" \
207     --parch "${ARCH}"
208     fi
209    
210  if [ -z "${BINDIR}" ]   exit 0
 then  
  die "no BINDIR variable found in /etc/mage.rc"  
211  fi  fi
212    
213  if [ -z "${CHOST}" ]  if [ "$1" == "--create-src-tarball" -a -n "$2" ]
214  then  then
215   die "no CHOST variable found in /etc/mage.rc"   # set correct SMAGENAME
216     SMAGENAME="$2"
217     MD5DIR="$(dirname ${SMAGENAME})/md5"
218    
219     echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
220    
221     smagesource ${SMAGENAME} || die "regen: smage2 not found"
222    
223     if [[ -d ${SOURCEDIR}/${PNAME} ]]
224     then
225     echo -e "${COLGREEN}Deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
226     rm -rf ${SOURCEDIR}/${PKGNAME}
227     fi
228    
229     download_sources
230     source_pkg_build ${SMAGENAME}
231     exit 0
232  fi  fi
233    
234  if [ -z "${CFLAGS}" ]  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
235  then  then
236   die "no CFLAGS variable found in /etc/mage.rc"   SRCPKGTARBALL="${2}"
237     msetfeature "srcpkgtarball"
238    
239     # abort if given file is not a source pkg
240     [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
241    
242     # set correct SMAGENAME; use the one that the src_pkg provide
243     # /path/to/SOURCEDIR/PNAME/SMAGENAME
244     SMAGENAME="${SOURCEDIR}/$(basename ${SRCPKGTARBALL%-*-*})/$(basename ${SRCPKGTARBALL} .${SRCPKGSUFFIX}).${SMAGESUFFIX}"
245    
246     echo -e "${COLGREEN}Using src-tarball ${COLBLUE}${SRCPKGTARBALL}${COLGREEN} ...${COLDEFAULT}"
247    
248     [[ ! -d ${SOURCEDIR} ]] && install -d ${SOURCEDIR}
249    
250     # unpack srctarball
251     [[ ! -f ${SRCPKGTARBALL} ]] && die "Error: ${SRCPKGTARBALL} does not exist. Aborting."
252    
253     tar xvjf ${SRCPKGTARBALL} -C ${SOURCEDIR} || die  "Error unpackung src-tarball ${SRCPKGTARBALL}"
254    
255     [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
256  fi  fi
257    
258  if [ -z "${CXXFLAGS}" ]  if [ "$1" == "--resume" -a -n "$2" ]
259  then  then
260   die "no CXXFLAGS variable found in /etc/mage.rc"   msetfeature "resume"
261     SMAGENAME="$2"
262  fi  fi
263    
264    [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."
265    [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
266     die "File '$(basename ${SMAGENAME})' is not a sMage v${SMAGEVERSION} file. Aborting."
267    [ -z "${SOURCEDIR}" ] && die "\$SOURCEDIR not found. Please setup your ${MAGERC} correctly."
268    [ -z "${SMAGESCRIPTSDIR}" ] && die "\$SMAGESCRIPTSDIR not found. Please setup your ${MAGERC} correctly."
269    [ -z "${SMAGE2RSYNC}" ] && die "\$SMAGE2RSYNC not found. Please setup your ${MAGERC} correctly."
270    [ -z "${BINDIR}" ] && die "no BINDIR variable found in ${MAGERC}"
271    [ -z "${CHOST}" ] && die "no CHOST variable found in ${MAGERC}"
272    [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
273    [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
274    
275  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
276  PKGNAME="${PNAME}-${PVER}-${CHOST%%-*}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}"
277  MD5DIR="$(dirname ${SMAGENAME})/md5"  MD5DIR="$(dirname ${SMAGENAME})/md5"
278    SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"
279    
280  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
281  echo "Compiling ${PKGNAME}"  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
282    
283  #download sources  # auto regen mage tree if requested
284  download_sources  regen_mage_tree
285    
286  #fixes some issues with these functions  if mqueryfeature "srcpkgbuild"
287    then
288     if [[ -d ${SOURCEDIR}/${PNAME} ]]
289     then
290     echo -e "${COLBLUE}===${COLGREEN} deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
291     rm -rf ${SOURCEDIR}/${PNAME}
292     fi
293    fi
294    
295    # download sources
296    mqueryfeature "srcpkgtarball" || download_sources
297    
298    # fixes some issues with these functions
299  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
300  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
301    export -f src_check || die "src_check export failed"
302  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
303    
304  #fixes some compile issues  # fixes some compile issues
305  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
306  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
307  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  if [[ -z ${CXXFLAGS} ]]
308    then
309     export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
310    else
311     export CXXFLAGS="${CXXFLAGS}" || die "CXXFLAGS export failed"
312    fi
313    export LDFLAGS="${LDFLAGS}" || die "LDFLAGS export failed"
314  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
315  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
316    
317    # setup distcc
318    # setup for distcc goes *before* ccache, so ccache comes before distcc in path
319    mqueryfeature "distcc" && setup_distcc_environment
320    
321  #setup distcc  # setup ccache
322  #distcc mus be setup *before* ccache, as ccache need to be before distcc in path  mqueryfeature "ccache" && setup_ccache_environment
 if [ "${SMAGE_USE_DISTCC}" == "true" ]  
 then  
  setup_distcc_environment  
 fi  
323    
324  #setup ccache  if mqueryfeature "resume"
 if [ "${SMAGE_USE_CCACHE}" == "true" ]  
325  then  then
326   setup_ccache_environment   echo -e "${COLMAGENTA}Resume requested; continuing previous build${COLDEFAULT}"
327  fi  
328     # setup build logging
329     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
330     if [[ -f /var/log/smage/${PKGNAME}.log.bz2 ]]
331     then
332     bunzip2 -f /var/log/smage/${PKGNAME}.log.bz2
333     fi
334     echo -e "### Resume started on $(date) ###\n" >> /var/log/smage/${PKGNAME}.log
335    
336    else
337     # clean up builddir if a previously one exist
338     if [ -d ${BUILDDIR} ]
339     then
340     rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
341     fi
342     install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
343    
344     # clean up srcdir if a previously unpacked one exist
345     if [ -d ${SRCDIR} ]
346     then
347     rm -rf ${SRCDIR}
348     fi
349    
350     # clean up bindir if a previous build exist or create a new one
351     if [ -d ${BINDIR} ]
352     then
353     rm -rf ${BINDIR}
354     fi
355     install -d ${BINDIR} || die "couldn't create \$BINDIR."
356    
357     # clean up package temp dir if a previous build exist
358     if [ -d ${BUILDDIR}/${PKGNAME} ]
359     then
360     rm -rf ${BUILDDIR}/${PKGNAME}
361     fi
362    
363  # small sleep to show our settings   # clean up stamps dir
364  sleep 1   if [ -d ${BUILDDIR}/.stamps ]
365     then
366     rm -rf ${BUILDDIR}/.stamps
367     fi
368    
369  #debug   # setup build logging
370  #echo "CC=${CC}"   [[ ! -d /var/log/smage ]] && install -d /var/log/smage
371  #echo "CXX=${CXX}"   echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
372  #echo "DISTCC_DIR=${DISTCC_DIR}"  fi
 #echo "PATH: ${PATH}"  
 #echo "--------------------------------------"  
 #env  
 #echo "--------------------------------------"  
 #read  
 #debug end  
373    
374  #cleans up build if a previously one exists  if [[ ${PKGTYPE} = virtual ]]
 if [ -d ${BUILDDIR} ]  
375  then  then
376   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   echo "virtual package detected; nothing will be build ..."
377     # automatically set !pkgbuild here too
378     msetfeature "!pkgbuild"
379    else
380     ( run_resume src_prepare || src_prepare ) | ${SMAGE_LOG_CMD}
381     die_pipestatus 0 "src_prepare failed"
382     resume_stamp src_prepare
383     step_by_step src_prepare
384    
385     ( run_resume src_compile || src_compile ) | ${SMAGE_LOG_CMD}
386     die_pipestatus 0 "src_compile failed"
387     resume_stamp src_compile
388     step_by_step src_compile
389    
390     # only run checks if requested
391     if mqueryfeature "!check"
392     then
393     echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
394     else
395     ( run_resume src_check || src_check ) | ${SMAGE_LOG_CMD}
396     die_pipestatus 0 "src_check failed"
397     resume_stamp src_check
398     fi
399     step_by_step src_check
400    
401     # build several subpackages
402     if [[ -n ${SPLIT_PACKAGES} ]]
403     then
404     # save bindir & pname
405     split_save_variables
406     export SAVED_BINDIR="${BINDIR}"
407     for subpackage in ${SPLIT_PACKAGES}
408     do
409     if typeset -f src_install_${subpackage} > /dev/null
410     then
411     # export subpackage bindir
412     export BINDIR="${SAVED_BINDIR}_${subpackage}"
413     # export PNAME, several internal function and include
414     # rely on this variable
415     export PNAME="${subpackage}"
416    
417     echo
418     echo -en "${COLBLUE}*** ${COLDEFAULT}"
419     echo -en "  Running ${COLGREEN}split src_install()${COLDEFAULT}"
420     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
421     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
422    
423     ( run_resume src_install_${subpackage} || src_install_${subpackage} ) | ${SMAGE_LOG_CMD}
424     die_pipestatus 0 "src_install_${subpackage} failed"
425     resume_stamp src_install_${subpackage}
426     step_by_step src_install_${subpackage}
427     fi
428     done
429     # restore bindir & pname
430     split_restore_variables
431     # unset all saved smage variables
432     split_unset_variables
433     else
434     ( run_resume src_install || src_install ) | ${SMAGE_LOG_CMD}
435     die_pipestatus 0 "src_install failed"
436     resume_stamp src_install
437     step_by_step src_install
438     fi
439  fi  fi
 install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  
440    
441  #cleans up srcdir if a previously unpacked one exists  # echo for sake of good-looking
442  if [ -d ${SRCDIR} ]  echo
443    
444    if mqueryfeature "!compressdoc"
445  then  then
446   rm -rf ${SRCDIR}   echo -e "!compressdoc detected; documentation will not be compressed ..."
447    elif mqueryfeature "!pkgbuild"
448    then
449     echo "!pkgbuild detected; skipping documentation compression..."
450    else
451     # compressing doc, info & man files
452     if [[ -n ${SPLIT_PACKAGES} ]]
453     then
454     for subpackage in ${SPLIT_PACKAGES}
455     do
456     run_resume post-mcompressdoc_${subpackage} || mcompressdocs ${BINDIR}_${subpackage}
457     resume_stamp post-mcompressdoc_${subpackage}
458     done
459     else
460     run_resume post-mcompressdoc || mcompressdocs ${BINDIR}
461     resume_stamp post-mcompressdoc
462     fi
463  fi  fi
464    
465  #cleans up bindir if a previous build exists or creates a new one  if mqueryfeature "!libtool"
 if [ -d ${BINDIR} ]  
466  then  then
467   rm -rf ${BINDIR}   if mqueryfeature "!pkgbuild"
468     then
469     echo "!pkgbuild detected; skipping libtool archive stripping ..."
470     else
471     if [[ -n ${SPLIT_PACKAGES} ]]
472     then
473     for subpackage in ${SPLIT_PACKAGES}
474     do
475     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
476     run_resume post-mstriplibtoolarchive_${subpackage} || mstriplibtoolarchive ${BINDIR}_${subpackage}
477     resume_stamp post-mstriplibtoolarchive_${subpackage}
478     done
479     else
480     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
481     run_resume post-mstriplibtoolarchive || mstriplibtoolarchive ${BINDIR}
482     resume_stamp post-mstriplibtoolarchive
483     fi
484     fi
485  fi  fi
 install -d ${BINDIR} || die "couldn't create \$BINDIR."  
486    
487  #cleans up package temp dir if a previous build exists  if mqueryfeature "purge"
 if [ -d ${BUILDDIR}/${PKGNAME} ]  
488  then  then
489   rm -rf ${BUILDDIR}/${PKGNAME}   if mqueryfeature "!pkgbuild"
490     then
491     echo "!pkgbuild detected; skipping file purgation..."
492     else
493     if [[ -n ${SPLIT_PACKAGES} ]]
494     then
495     for subpackage in ${SPLIT_PACKAGES}
496     do
497     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
498     run_resume post-mpurgetargets_${subpackage} || mpurgetargets ${BINDIR}_${subpackage}
499     resume_stamp post-mpurgetargets_${subpackage}
500     done
501     else
502     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
503     run_resume post-mpurgetargets || mpurgetargets ${BINDIR}
504     resume_stamp post-mpurgetargets
505     fi
506     fi
507  fi  fi
508    
509  #cleans up timestamp if one exists  # stripping all bins and libs
510  if [ -f /var/tmp/timestamp ]  if mqueryfeature "!strip"
511    then
512     echo -e "!strip detected; Package will not be stripped ..."
513    elif mqueryfeature "!pkgbuild"
514  then  then
515   mage rmstamp   echo "!pkgbuild detected; skipping stripping of the package ..."
516    else
517     if [[ -n ${SPLIT_PACKAGES} ]]
518     then
519     for subpackage in ${SPLIT_PACKAGES}
520     do
521     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
522     run_resume post-mstripbins_${subpackage} || mstripbins ${BINDIR}_${subpackage}
523     resume_stamp post-mstripbins_${subpackage}
524     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
525     run_resume post-mstriplibs_${subpackage} || mstriplibs ${BINDIR}_${subpackage}
526     resume_stamp post-mstriplibs_${subpackage}
527     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
528     run_resume post-mstripstatic_${subpackage} || mstripstatic ${BINDIR}_${subpackage}
529     resume_stamp post-mstripstatic_${subpackage}
530     done
531     else
532     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
533     run_resume post-mstripbins || mstripbins ${BINDIR}
534     resume_stamp post-mstripbins
535     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
536     run_resume post-mstriplibs || mstriplibs ${BINDIR}
537     resume_stamp post-mstriplibs
538     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
539     run_resume post-mstripstatic || mstripstatic ${BINDIR}
540     resume_stamp post-mstripstatic
541     fi
542  fi  fi
543    
544  src_prepare || die "src_prepare failed"  if mqueryfeature "!pkgbuild"
545  src_compile || die "src_compile failed"  then
546  src_install || die "src_install failed"   echo -e "!pkgbuild detected; Package will not be build ..."
547    else
548     # build several targets
549     if [[ -n ${MAGE_TARGETS} ]]
550     then
551     for target in ${MAGE_TARGETS}
552     do
553     # check if a special target_pkgbuild exists
554     if typeset -f ${target}_pkgbuild > /dev/null
555     then
556     # run it
557     run_resume post-${target}_pkgbuild || ${target}_pkgbuild
558     resume_stamp post-${target}_pkgbuild
559     fi
560     # now create the target package
561     run_resume post-pkg_builddir_${target} || ${MLIBDIR}/pkgbuild_dir.sh \
562     "${PNAME}-${target}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
563     ${BINDIR} || die "target: ${target} package-build failed"
564     resume_stamp post-pkg_builddir_${target}
565    
566     # build pkg-md5-sum if requested
567     run_resume post-md5sum_${target} || generate_package_md5sum \
568     --pcat "${PCAT}" \
569     --pname "${PNAME}" \
570     --pver "${PVER}" \
571     --pbuild "${PBUILD}" \
572     --parch "${ARCH}" \
573     --target "${target}"
574     resume_stamp post-md5sum_${target}
575    
576     echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
577     done
578    
579  #compressing doc, info & man files   # build several subpackages
580  echo -e "Compressing man-pages ..."   elif [[ -n ${SPLIT_PACKAGES} ]]
581  if [ -d ${BUILDDIR}/builded/usr/share/man ]   then
582  then   split_save_variables
583   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man   for subpackage in ${SPLIT_PACKAGES}
584     do
585     # get the right variables for the split
586     export PNAME="${subpackage}"
587     split_info_${PNAME}
588     # fix PCATEGORIE -> PCAT
589     if [[ ! -z ${PCATEGORIE} ]]
590     then
591     PCAT="${PCATEGORIE}"
592     unset PCATEGORIE
593     fi
594    
595     # jump to next one if !pkgbuild is set in split_info
596     mqueryfeature "!pkgbuild" && continue
597    
598     # check if an special subpackage_pkgbuild exists
599     if typeset -f ${PNAME}_pkgbuild > /dev/null
600     then
601     # run it
602     run_resume post-${PNAME}_pkgbuild || ${PNAME}_pkgbuild
603     resume_stamp post-${PNAME}_pkgbuild
604     fi
605     # now create the target package
606     run_resume post-pkg_builddir_${PNAME} || ${MLIBDIR}/pkgbuild_dir.sh \
607     "${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
608     "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
609     resume_stamp post-pkg_builddir_${PNAME}
610    
611     # build pkg-md5-sum if requested
612     run_resume post-md5sum_${PNAME} || generate_package_md5sum \
613     --pcat "${PCAT}" \
614     --pname "${PNAME}" \
615     --pver "${PVER}" \
616     --pbuild "${PBUILD}" \
617     --parch "${ARCH}"
618     resume_stamp post-md5sum_${PNAME}
619    
620     echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
621    
622     # restore smage environment
623     split_restore_variables
624     done
625     # unset all saved smage variables
626     split_unset_variables
627    
628     else
629     run_resume post-pkg_builddir || ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"
630     resume_stamp post-pkg_builddir
631    
632     # build pkg-md5-sum if requested
633     run_resume post-md5sum || generate_package_md5sum \
634     --pcat "${PCAT}" \
635     --pname "${PNAME}" \
636     --pver "${PVER}" \
637     --pbuild "${PBUILD}" \
638     --parch "${ARCH}"
639     resume_stamp post-md5sum
640    
641     echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
642     fi
643    
644     # build src-pkg-tarball if requested
645     if mqueryfeature "srcpkgbuild"
646     then
647     run_resume post-srcpkgbuild || source_pkg_build ${SMAGENAME}
648     resume_stamp post-srcpkgbuild
649     fi
650  fi  fi
651    
652  echo -e "Compressing info-pages ..."  if mqueryfeature "buildlog"
 if [ -d ${BUILDDIR}/builded/usr/share/info ]  
653  then  then
654   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   bzip2 -9f /var/log/smage/${PKGNAME}.log
655    else
656     [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
657  fi  fi
658    
 # stripping all bins and libs  
 case ${NOSTRIP} in  
  true|TRUE|yes|y)  
  echo -e "NOSTRIP=true detected; Package will not be stripped ..."  
  ;;  
  *)  
  echo -e "Stripping binaries ..."  
  mstripbins ${BINDIR}  
  echo -e "Stripping libraries ..."  
  mstriplibs ${BINDIR}  
  ;;  
 esac  
   
 #the new buildpkg command  
 case ${NOPKGBUILD} in  
  true|TRUE|yes|y)  
  echo -e "NOPGKBUILD=true detected; Package will not be build ..."  
  ;;  
  *)  
  ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"  
  echo -e "\nPackage ${PKGNAME} successfully builded.\n"  
  ;;  
 esac  
   
 #for sure  
 unset NOPKGBUILD  
 unset NOSTRIP  
   
659  xtitleclean  xtitleclean
 #echo -e "\nPackage ${PKGNAME} successfully builded.\n"  

Legend:
Removed from v.85  
changed lines
  Added in v.1659